



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Flume-ng源码解析之Source组件</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Flume-ng源码解析之Source组件</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 23:23:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>如果你还没看过Flume-ng源码解析系列中的启动流程、Channel组件和Sink组件，可以点击下面链接：<br /><br />
<a href="http://blog.csdn.net/u011812294/article/details/60878890" rel="external nofollow noreferrer">Flume-ng源码解析之启动流程</a><br /><br />
<a href="http://blog.csdn.net/u011812294/article/details/60882000" rel="external nofollow noreferrer">Flume-ng源码解析之Channel组件</a><br /><br />
<a href="http://blog.csdn.net/u011812294/article/details/61203542" rel="external nofollow noreferrer">Flume-ng源码解析之Sink组件</a></p>
<p>在前面三篇文章中我们初步了解了Flume的启动流程、Channel组件和Sink组件，接下来我们一起来看看agent三大组件中Source组件。</p>
<h1>1 Source</h1>
<p>Source，作为agent中的消息来源组件，我们来看看它是如何将event传递给channel的和它的特性。</p>
<p>依然先看代码：</p>
<pre class="prettyprint linenums"><code>@InterfaceAudience.Public<br />
@InterfaceStability.Stable<br />
public interface Source extends LifecycleAware, NamedComponent {<br />
  public void setChannelProcessor(ChannelProcessor channelProcessor);<br />
  public ChannelProcessor getChannelProcessor();<br />
}<br />
</code></pre>
<p>我们可以看到它里面定义的两个需要实现方法是getChannelProcessor和setChannelProcessor，我们大概可以猜到，source就是通过ChannelProcessor将event传输给channel的。</p>
<p>这里先来了解一下Source的类型，Flume根据数据来源的特性将Source分成两类类，像Http、netcat和exec等就是属于事件驱动型（EventDrivenSource），而kafka和Jms等就是属于轮询拉取型（PollableSource）。</p>
<p>据我们在启动流程中了解到的，Application是先启动SourceRunner，再由SourceRunner来启动source，那么既然source有两种类型，那么Sourcerunner也分为EventDrivenSourceRunner和PollableSourceRunner，我们来看看它们的start()：</p>
<p><strong>EventDrivenSourceRunner</strong></p>
<pre class="prettyprint linenums"><code>public class EventDrivenSourceRunner extends SourceRunner {<br />
  …<br />
  @Override<br />
  public void start() {<br />
    Source source = getSource();<br />
    ChannelProcessor cp = source.getChannelProcessor();<br />
    cp.initialize();<br />
    source.start();<br />
    lifecycleState = LifecycleState.START;<br />
  }<br />
  …<br />
}<br />
</code></pre>
<p><strong>PollableSourceRunner</strong></p>
<pre class="prettyprint linenums"><code>public class PollableSourceRunner extends SourceRunner {

  …<br />
  @Override<br />
  public void start() {<br />
    PollableSource source = (PollableSource) getSource();<br />
    ChannelProcessor cp = source.getChannelProcessor();<br />
    cp.initialize();<br />
    source.start();

    runner = new PollingRunner();

    runner.source = source;<br />
    runner.counterGroup = counterGroup;<br />
    runner.shouldStop = shouldStop;

    runnerThread = new Thread(runner);<br />
    runnerThread.setName(getClass().getSimpleName() + &quot;-&quot; +<br />
        source.getClass().getSimpleName() + &quot;-&quot; + source.getName());<br />
    runnerThread.start();

    lifecycleState = LifecycleState.START;<br />
  }

  …<br />
  public static class PollingRunner implements Runnable {

    private PollableSource source;<br />
    private AtomicBoolean shouldStop;<br />
    private CounterGroup counterGroup;

    @Override<br />
    public void run() {<br />
      logger.debug(&quot;Polling runner starting. Source:{}&quot;, source);

      while (!shouldStop.get()) {<br />
        counterGroup.incrementAndGet(&quot;runner.polls&quot;);

        try {<br />
          if (source.process().equals(PollableSource.Status.BACKOFF)) {<br />
            counterGroup.incrementAndGet(&quot;runner.backoffs&quot;);

            Thread.sleep(Math.min(<br />
                counterGroup.incrementAndGet(&quot;runner.backoffs.consecutive&quot;)<br />
                * source.getBackOffSleepIncrement(), source.getMaxBackOffSleepInterval()));<br />
          } else {<br />
            counterGroup.set(&quot;runner.backoffs.consecutive&quot;, 0L);<br />
          }<br />
        } catch (InterruptedException e) {<br />
          logger.info(&quot;Source runner interrupted. Exiting&quot;);<br />
          counterGroup.incrementAndGet(&quot;runner.interruptions&quot;);<br />
        } catch (EventDeliveryException e) {<br />
          logger.error(&quot;Unable to deliver event. Exception follows.&quot;, e);<br />
          counterGroup.incrementAndGet(&quot;runner.deliveryErrors&quot;);<br />
        } catch (Exception e) {<br />
          counterGroup.incrementAndGet(&quot;runner.errors&quot;);<br />
          logger.error(&quot;Unhandled exception, logging and sleeping for &quot; +<br />
              source.getMaxBackOffSleepInterval() + &quot;ms&quot;, e);<br />
          try {<br />
            Thread.sleep(source.getMaxBackOffSleepInterval());<br />
          } catch (InterruptedException ex) {<br />
            Thread.currentThread().interrupt();<br />
          }<br />
        }<br />
      }

      logger.debug(&quot;Polling runner exiting. Metrics:{}&quot;, counterGroup);<br />
    }

  }

}<br />
</code></pre>
<p>无论是PollableSourceRunner还是EventDrivenSourceRunner，都是调用它里面的source的start()。这个时候我们看到ChannelProcessor的存在，那么就会有疑惑，这ChannelProcessor哪来的？我们还是得看回AbstarctConfigurationProvider，查看里面的loadSources()，我们就会发现下面这段代码：</p>
<pre class="prettyprint linenums"><code>ChannelSelectorConfiguration selectorConfig = config.getSelectorConfiguration();<br />
ChannelSelector selector = ChannelSelectorFactory.create(sourceChannels, selectorConfig);<br />
ChannelProcessor channelProcessor = new ChannelProcessor(selector);<br />
Configurables.configure(channelProcessor, config);<br />
source.setChannelProcessor(channelProcessor);<br />
</code></pre>
<p>到这里我们基本已经了解了Source的启动流程，下面以AvroSource为例看看，source是在哪里调用ChannelProcessor的插入方法。</p>
<h1>2 AvroSource</h1>
<pre class="prettyprint linenums"><code>public class AvroSource extends AbstractSource implements EventDrivenSource,<br />
    Configurable, AvroSourceProtocol {<br />
  …<br />
  @Override<br />
  public Status append(AvroFlumeEvent avroEvent) {<br />
    if (logger.isDebugEnabled()) {<br />
      if (LogPrivacyUtil.allowLogRawData()) {<br />
        logger.debug(&quot;Avro source {}: Received avro event: {}&quot;, getName(), avroEvent);<br />
      } else {<br />
        logger.debug(&quot;Avro source {}: Received avro event&quot;, getName());<br />
      }<br />
    }

    sourceCounter.incrementAppendReceivedCount();<br />
    sourceCounter.incrementEventReceivedCount();

    Event event = EventBuilder.withBody(avroEvent.getBody().array(),<br />
        toStringMap(avroEvent.getHeaders()));

    try {<br />
      getChannelProcessor().processEvent(event);<br />
    } catch (ChannelException ex) {<br />
      logger.warn(&quot;Avro source &quot; + getName() + &quot;: Unable to process event. &quot; +<br />
          &quot;Exception follows.&quot;, ex);<br />
      return Status.FAILED;<br />
    }

    sourceCounter.incrementAppendAcceptedCount();<br />
    sourceCounter.incrementEventAcceptedCount();

    return Status.OK;<br />
  }

  @Override<br />
  public Status appendBatch(List&lt;AvroFlumeEvent&gt; events) {<br />
    logger.debug(&quot;Avro source {}: Received avro event batch of {} events.&quot;,<br />
        getName(), events.size());<br />
    sourceCounter.incrementAppendBatchReceivedCount();<br />
    sourceCounter.addToEventReceivedCount(events.size());

    List&lt;Event&gt; batch = new ArrayList&lt;Event&gt;();

    for (AvroFlumeEvent avroEvent : events) {<br />
      Event event = EventBuilder.withBody(avroEvent.getBody().array(),<br />
          toStringMap(avroEvent.getHeaders()));

      batch.add(event);<br />
    }

    try {<br />
      getChannelProcessor().processEventBatch(batch);<br />
    } catch (Throwable t) {<br />
      logger.error(&quot;Avro source &quot; + getName() + &quot;: Unable to process event &quot; +<br />
          &quot;batch. Exception follows.&quot;, t);<br />
      if (t instanceof Error) {<br />
        throw (Error) t;<br />
      }<br />
      return Status.FAILED;<br />
    }

    sourceCounter.incrementAppendBatchAcceptedCount();<br />
    sourceCounter.addToEventAcceptedCount(events.size());

    return Status.OK;<br />
  }<br />
  …<br />
}

</code></pre>
<p>在append方法中我们可以看到getChannelProcessor().processEvent(event);，所以不同的Source根据它的不同触发机制和拉取机制，在特定的时候调用ChannelProcessor来执行event的插入。	·</p>
<p><strong>到此为止，我们就完成了对Flume启动流程和三大组件的研究，鉴于能力，其中有些细节没办法深入研究，希望以后有时间能够继续深入分析下去。</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390r2zm9.html">每周一书-《鸟哥的Linux私房菜基础学习篇&lpar;第四版&rpar;》台湾原版，你想要吗？</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlpyzk9.html">关于SharPoint2013一点细节的深究</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zlew1q.html">MMORPG大型游戏设计与开发（客户端架构 part2 of vegine）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydw7wgq.html">Function&comma; Predicate</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wmw1oq.html">new tips</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o7lwj9.html">QCon2013上海站总结 -- 整体印象和感悟</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v4m5j8.html">根据url获取网页内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj74p79.html">unity 3d-Easy Touch 3教程 转</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1znyz09.html">php学习，一个简单的Calendar&lpar;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w1133q.html">OBJECT和EMBED标签（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdem1n79.html">o&ZeroWidthSpace;r&ZeroWidthSpace;a&ZeroWidthSpace;l&ZeroWidthSpace;c&ZeroWidthSpace;e&ZeroWidthSpace; &ZeroWidthSpace;D&ZeroWidthSpace;B&ZeroWidthSpace;A&ZeroWidthSpace; &ZeroWidthSpace;培&ZeroWidthSpace;训&lowbar;lesson06</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vwgrn8.html">BZOJ 4305&colon; 数列的GCD&lpar; 数论 &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj16gk8.html">VSC调试&period;NET Core 应用程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey37de9.html">oracle客户端plsql设置字符集</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgwg1d8.html">关于hue安装后出现KeyError&colon; &amp;quot&semi;Couldn&amp;&num;39&semi;t get user id for user hue&amp;quot&semi;的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvmx738.html">python之路-python2&period;x与python3&period;x区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r5m648.html">vue2&period;0之axios使用详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2jwoz9.html">Django学习笔记之数据库-QuerySet&lowbar;API</a>
		</li>
						<li><a href="https://www.batexi.com/a/953rdpm8.html">sql语句截取字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vl534q.html">UVA-572-搜索基础题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2jm1ew8.html">ThinkPHP--IS&lowbar;AJAX</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj5mdy8.html">jQuery插入节点（移动节点）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yd46w8.html">Debian8 安装wordpress博客</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpd75zq.html">Hadoop权威指南&colon;压缩</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj2px38.html">Accessibility辅助功能--一念天堂，一念地狱</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojvzmlq.html">java打包jar&comma;war&comma;ear包的作用、区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge42lz8.html">OSS&period;Common扩展&period;Net Standard支持实例分享</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yd5nz8.html">Applovin Interview &lpar;面经&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj5ej19.html">剖析Asp&period;Net Web API路由系统---WebHost部署方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1rw4xq.html">MongoDB学习总结&lpar;五&rpar; &mdash;&mdash; 安全认证</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
